searchNodes=[{"doc":"AntlPhonenumber is a third-party port of the google libphonenumber library . The library is based on google libphonenumber cpp implementation and implements NIF functions. Installation If available in Hex , the package can be installed by adding antl_phonenumber to your list of dependencies in mix.exs : def deps do [ { :antl_phonenumber , &quot;~&gt; 0.1.1&quot; } ] end The library supposes that google libphonenumber is installed. Please refer to the installation doc of C++ version to build the library. Usage AntlPhonenumber provides a set of predicates and functions to check or manipulate a number. Ecto types It also provides a PlusE164 Ecto type ensuring the number will be dump and load only in plus e164 format and a E164 Ecto type ensuring the number will be dump and load only in e164 format. A number in any other format won't be cast, as country code is required to format it in plus e164 format. However, if iso_country_code is specified, the type will ensure the number belongs to the given country code and casting will be performed accordingly to this country code. In that case, any number of another country (a.k.a any plus_e164 of another country) will cause casting to fail. Example: import AntlPhonenumber.Ecto.PlusE164 embedded_schema do field ( :number , PlusE164 ) field ( :french_number , PlusE164 , iso_country_code : &quot;FR&quot; ) field ( :e164 , E164 ) field ( :french_e164 , E164 , iso_country_code : &quot;FR&quot; ) end PlusE164 and E164 fit our needs but any type can be created to express a combination of number characteristics. For instance, one could need a type for local french numbers. It is easy to implement another type based on existing implementation. Ecto changeset Changeset validations are also a AntlPhonenumber feature. For the moment, the validators are: validate_iso_country_code / 3 validate_type / 3 Ranges Number ranges are also supported and implement the Enumerable protocol so we can apply Enum functions on them. The ranges can be ascendant or descendant. For example: range = AntlPhonenumber.Range . new ( &quot;+33148413200&quot; , &quot;+33148413210&quot; , &quot;FR&quot; ) range = AntlPhonenumber.Range . new ( &quot;0148413200&quot; , &quot;0148413210&quot; , &quot;FR&quot; ) range = AntlPhonenumber.Range . new ( &quot;0148413210&quot; , &quot;0148413200&quot; , &quot;FR&quot; ) Testing Google provides number examples. The function get_plus_e164_example/2, receiving a country code and a number type allow to request an example number. It is useful for testing. AntlPhonenumber . get_plus_e164_example ( &quot;FR&quot; , :mobile )","ref":"AntlPhonenumber.html","title":"AntlPhonenumber","type":"module"},{"doc":"Returns the country prefix of the number. Note that the number must be formatted in plus_e164 format.","ref":"AntlPhonenumber.html#get_country_code!/1","title":"AntlPhonenumber.get_country_code!/1","type":"function"},{"doc":"Returns the country code of the number. Note that the number must be formatted in plus_e164 format.","ref":"AntlPhonenumber.html#get_iso_country_code!/1","title":"AntlPhonenumber.get_iso_country_code!/1","type":"function"},{"doc":"Get from Google a plus e164 number.","ref":"AntlPhonenumber.html#get_plus_e164_example/2","title":"AntlPhonenumber.get_plus_e164_example/2","type":"function"},{"doc":"Returns the type of the number. It can be one of the list below: (premium_rate,toll_free,mobile,fixed_line,shared_cost,voip,personal_number,pager,uan,voicemail). Note that if the number is not formatted in plus_e164 nor in e164 format, a reference iso_country_code is required.","ref":"AntlPhonenumber.html#get_type/1","title":"AntlPhonenumber.get_type/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#get_type/2","title":"AntlPhonenumber.get_type/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#move/3","title":"AntlPhonenumber.move/3","type":"function"},{"doc":"Returns true if the number is well-formatted in plus_e164 format. Otherwise, returns false.","ref":"AntlPhonenumber.html#plus_e164?/1","title":"AntlPhonenumber.plus_e164?/1","type":"function"},{"doc":"Returns true if the number is possible. Otherwise, returns false. Note that if the number is not formatted in plus_e164 nor in e164 format, a reference iso_country_code is required to determine the possibility of the number.","ref":"AntlPhonenumber.html#possible?/1","title":"AntlPhonenumber.possible?/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#possible?/2","title":"AntlPhonenumber.possible?/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#supported_types/0","title":"AntlPhonenumber.supported_types/0","type":"function"},{"doc":"Format a number to e164 (without plus) format. Note that if the number is not formatted in plus_e164 format nor in e164 , a reference iso_country_code is required.","ref":"AntlPhonenumber.html#to_e164/1","title":"AntlPhonenumber.to_e164/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#to_e164/2","title":"AntlPhonenumber.to_e164/2","type":"function"},{"doc":"Same as c:to_e164/1 and c:to_e164/2 , but raises on parsing/formatting error.","ref":"AntlPhonenumber.html#to_e164!/1","title":"AntlPhonenumber.to_e164!/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#to_e164!/2","title":"AntlPhonenumber.to_e164!/2","type":"function"},{"doc":"Returns the country code corresponding to the country prefix.","ref":"AntlPhonenumber.html#to_iso_country_code!/1","title":"AntlPhonenumber.to_iso_country_code!/1","type":"function"},{"doc":"Format a number to local format. Note that if the number is not formatted in plus_e164 nor in e164 format, a reference iso_country_code is required.","ref":"AntlPhonenumber.html#to_local/1","title":"AntlPhonenumber.to_local/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#to_local/2","title":"AntlPhonenumber.to_local/2","type":"function"},{"doc":"Format a number to plus_e164 format. Note that if the number is not formatted in plus_e164 nor in e164 format, a reference iso_country_code is required.","ref":"AntlPhonenumber.html#to_plus_e164/1","title":"AntlPhonenumber.to_plus_e164/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#to_plus_e164/2","title":"AntlPhonenumber.to_plus_e164/2","type":"function"},{"doc":"Same as c:to_plus_e164/1 and c:to_plus_e164/2 , but raises on parsing/formatting error.","ref":"AntlPhonenumber.html#to_plus_e164!/1","title":"AntlPhonenumber.to_plus_e164!/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#to_plus_e164!/2","title":"AntlPhonenumber.to_plus_e164!/2","type":"function"},{"doc":"Returns true if the number is valid. Otherwise, returns false. Note that if the number is not formatted in plus_e164 nor in e164 format, a reference iso_country_code is required to determine the validity of the number.","ref":"AntlPhonenumber.html#valid?/1","title":"AntlPhonenumber.valid?/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.html#valid?/2","title":"AntlPhonenumber.valid?/2","type":"function"},{"doc":"Returns true if the number is well-formatted in plus_e164 format and is valid. Otherwise, returns false.","ref":"AntlPhonenumber.html#valid_plus_e164_number?/1","title":"AntlPhonenumber.valid_plus_e164_number?/1","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html","title":"AntlPhonenumber.Nif","type":"module"},{"doc":"","ref":"AntlPhonenumber.Nif.html#format/3","title":"AntlPhonenumber.Nif.format/3","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#get_country_code/2","title":"AntlPhonenumber.Nif.get_country_code/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#get_plus_e164_example/2","title":"AntlPhonenumber.Nif.get_plus_e164_example/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#get_type/2","title":"AntlPhonenumber.Nif.get_type/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#init/0","title":"AntlPhonenumber.Nif.init/0","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#is_possible/2","title":"AntlPhonenumber.Nif.is_possible/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#is_valid/2","title":"AntlPhonenumber.Nif.is_valid/2","type":"function"},{"doc":"","ref":"AntlPhonenumber.Nif.html#to_iso_country_code/1","title":"AntlPhonenumber.Nif.to_iso_country_code/1","type":"function"},{"doc":"Defines a range of phone numbers.","ref":"AntlPhonenumber.Range.html","title":"AntlPhonenumber.Range","type":"module"},{"doc":"Creates a new range. Examples iex&gt; AntlPhonenumber.Range . new &quot;0548451840&quot; , &quot;0548451845&quot; , &quot;IL&quot; % AntlPhonenumber.Range { first : &quot;972548451840&quot; , last : &quot;972548451845&quot; , iso_country_code : &quot;IL&quot; }","ref":"AntlPhonenumber.Range.html#new/3","title":"AntlPhonenumber.Range.new/3","type":"function"},{"doc":"","ref":"AntlPhonenumber.Range.html#t:t/0","title":"AntlPhonenumber.Range.t/0","type":"type"},{"doc":"AntlPhonenumber is a third-party port of the google libphonenumber library . The library is based on google libphonenumber cpp implementation and implements NIF functions.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding antl_phonenumber to your list of dependencies in mix.exs : def deps do [ { :antl_phonenumber , &quot;~&gt; 0.1.1&quot; } ] end The library supposes that google libphonenumber is installed. Please refer to the installation doc of C++ version to build the library.","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"AntlPhonenumber provides a set of predicates and functions to check or manipulate a number. Ecto types It also provides a PlusE164 Ecto type ensuring the number will be dump and load only in plus e164 format and a E164 Ecto type ensuring the number will be dump and load only in e164 format. A number in any other format won't be cast, as country code is required to format it in plus e164 format. However, if iso_country_code is specified, the type will ensure the number belongs to the given country code and casting will be performed accordingly to this country code. In that case, any number of another country (a.k.a any plus_e164 of another country) will cause casting to fail. Example: import AntlPhonenumber.Ecto.PlusE164 embedded_schema do field ( :number , PlusE164 ) field ( :french_number , PlusE164 , iso_country_code : &quot;FR&quot; ) field ( :e164 , E164 ) field ( :french_e164 , E164 , iso_country_code : &quot;FR&quot; ) end PlusE164 and E164 fit our needs but any type can be created to express a combination of number characteristics. For instance, one could need a type for local french numbers. It is easy to implement another type based on existing implementation. Ecto changeset Changeset validations are also a AntlPhonenumber feature. For the moment, the validators are: validate_iso_country_code / 3 validate_type / 3 Ranges Number ranges are also supported and implement the Enumerable protocol so we can apply Enum functions on them. The ranges can be ascendant or descendant. For example: range = AntlPhonenumber.Range . new ( &quot;+33148413200&quot; , &quot;+33148413210&quot; , &quot;FR&quot; ) range = AntlPhonenumber.Range . new ( &quot;0148413200&quot; , &quot;0148413210&quot; , &quot;FR&quot; ) range = AntlPhonenumber.Range . new ( &quot;0148413210&quot; , &quot;0148413200&quot; , &quot;FR&quot; ) Testing Google provides number examples. The function get_plus_e164_example/2, receiving a country code and a number type allow to request an example number. It is useful for testing. AntlPhonenumber . get_plus_e164_example ( &quot;FR&quot; , :mobile )","ref":"readme.html#usage","title":"Readme - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"}]